package com.jz.sms.api;

import com.alibaba.fastjson.JSONObject;
import com.jz.sms.chuanlan.service.ChuanLanSmsService;
import com.jz.sms.dto.XfaceDmHubTemplateRequestDTO;
import com.jz.sms.dto.XfaceDmHubTemplateResponseDTO;
import com.jz.sms.service.MessageService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpRequest;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Enumeration;
import java.util.Map;

@RestController
@RequestMapping("/test")
public class BizController {

    private static final Logger log = LoggerFactory.getLogger(BizController.class);


    @Autowired
    private MessageService messageService;


    /**
     * 创建短信模板
     *
     * @return
     */
    @PostMapping("/sms/template")
    public String template(@RequestBody XfaceDmHubTemplateRequestDTO params) {
        log.info("**********创建模板入参*******：{}", JSONObject.toJSONString(params));
        XfaceDmHubTemplateResponseDTO template = messageService.createTemplate(params);

        return "ok";
    }


    /**
     * 批量发送（通知或营销类）
     *
     * @return
     */
    @PostMapping("/sms/batch")
    public String batch(@RequestParam Map<String, Object> params) {

        log.info("**********批量发送入参*******：{}", params);
        return "success";
    }


    /**
     * 发送单条（通知或营销类）
     *
     * @return
     */
    @RequestMapping("/sms/send")
    public String send(@RequestParam Map<String, Object> params) {

        log.info("**********单条发送入参*******：{}", params);
        return "success";
    }


}
