package com.jz.sms.chuanlan.service.impl;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.jz.sms.api.BizController;
import com.jz.sms.chuanlan.dto.XfaceClSendFiexdRequestDTO;
import com.jz.sms.chuanlan.dto.XfaceClSendFiexdResponseDTO;
import com.jz.sms.chuanlan.dto.XfaceClTemplateRequestDTO;
import com.jz.sms.chuanlan.dto.XfaceClTemplateResponseDTO;
import com.jz.sms.chuanlan.service.ChuanLanSmsService;
import com.jz.sms.chuanlan.utils.ChuangLanSmsUtil;
import com.jz.sms.config.SMSConfig;
import com.jz.sms.dto.*;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Service;
import sun.swing.StringUIClientPropertyKey;

import java.util.ArrayList;
import java.util.List;


@SuppressWarnings("DuplicatedCode")
@Service
public class ChuanLanSmsServiceImpl implements ChuanLanSmsService {

    private static final Logger log = LoggerFactory.getLogger(BizController.class);

    @Override
    public XfaceDmHubTemplateResponseDTO createTemplate(XfaceDmHubTemplateRequestDTO requestDTO) {
        /**
         * 调用创蓝的业务逻辑.....
         * requestDTO.getXXX....
         */
        XfaceClTemplateRequestDTO clRequestDto = new XfaceClTemplateRequestDTO();
        XfaceClTemplateResponseDTO clResponseDTO = new XfaceClTemplateResponseDTO();
        /**
         * 调用结果包装到DM Hub Response中
         */
        XfaceDmHubTemplateResponseDTO responseDTO = new XfaceDmHubTemplateResponseDTO();

        return responseDTO;
    }

    @Override
    public XfaceClSendFiexdResponseDTO sendByFixed(String batchId, String content, List<String> phoneList, String type) throws Exception {
        String account;
        String password;
        if ("notification".equals(type)) {
            account = SMSConfig.notificationAccount;
            password = SMSConfig.notificationPassword;
            log.info("发送短信的模式为：{通知类}");
        } else if ("marketing".equals(type)) {
            account = SMSConfig.marketingAccount;
            password = SMSConfig.marketingPassword;
            log.info("发送短信的模式为：{营销类}");
        } else {
            log.info("发送短信的模式为：{未知类型}");
            throw new Exception("123");
        }

        XfaceClSendFiexdRequestDTO request = new XfaceClSendFiexdRequestDTO(account, password, content, listToString(phoneList), "true", batchId);

        String requestJson = JSONObject.toJSONString(request);
        log.info("【{}】发送固定内容短信,请求上游数据为：{}", batchId, requestJson);
        String responseStr = ChuangLanSmsUtil.sendSmsByPost(SMSConfig.sendFixed, requestJson);
        log.info("【{}】发送固定内容短信,上游返回数据为：{}", batchId, requestJson);

        if (StringUtils.isBlank(responseStr)) {
            return new XfaceClSendFiexdResponseDTO("500", "渠道同步响应为空");
        }
        XfaceClSendFiexdResponseDTO response = JSON.parseObject(responseStr, XfaceClSendFiexdResponseDTO.class);
        return response;
    }

    private String listToString(List<String> list) {
        String s = list.toString();
        return s;
    }

    public static void main(String[] args) {
        List<String> arr = new ArrayList<>();
        arr.add("aa,444");
        System.out.printf(arr.toString());
    }

    @Override
    public XfaceClSendFiexdResponseDTO sendByVariable(String batchId, String content, List<String> params, String type) throws Exception {
        String account;
        String password;
        if ("notification".equals(type)) {
            account = SMSConfig.notificationAccount;
            password = SMSConfig.notificationPassword;
            log.info("发送短信的模式为：{通知类}");
        } else if ("marketing".equals(type)) {
            account = SMSConfig.marketingAccount;
            password = SMSConfig.marketingPassword;
            log.info("发送短信的模式为：{营销类}");
        } else {
            log.info("发送短信的模式为：{未知类型}");
            throw new Exception("123");
        }

        XfaceClSendFiexdRequestDTO request = new XfaceClSendFiexdRequestDTO(account, password, content, listToString(params), "true", batchId);

        String requestJson = JSONObject.toJSONString(request);
        log.info("【{}】发送固定内容短信,请求上游数据为：{}", batchId, requestJson);
        String responseStr = ChuangLanSmsUtil.sendSmsByPost(SMSConfig.sendFixed, requestJson);
        log.info("【{}】发送固定内容短信,上游返回数据为：{}", batchId, requestJson);

        if (StringUtils.isBlank(responseStr)) {
            return new XfaceClSendFiexdResponseDTO("500", "渠道同步响应为空");
        }
        XfaceClSendFiexdResponseDTO response = JSON.parseObject(responseStr, XfaceClSendFiexdResponseDTO.class);
        return response;
    }

    @Override
    public XfaceDmHubSendResponseDTO sendBatchByFixed(XfaceDmHubSendRequestDTO requestDTO) {
        return null;
    }

    @Override
    public XfaceDmHubBatchSendResponseDTO sendBatchByVariable(XfaceDmHubBatchSendRequestDTO requestDTO) {
        return null;
    }
}
